# MaxAxe (Throw Things)

## Throw Axes, Knives, Maces, Swords, Flaming Torches, Stones, Shields & Tankards. Stack throwing weapons. Frostner returns when thrown!

- Ever wonder why a Viking's axe (of all things) wouldn't be a weapon of choice? And why you couldn't throw them?
- Throw Axes, Clubs, Torches, Swords, Knives, and Maces
- Channel the spirit of Mjolnir; throw Frostner and have it return! 
- Throw Shields! Unsling your round shield and send it spinning at your enemy like Cap.
- Throw Stones! Whack a Greyling, annoy a Troll, send feathers flying, be a Hobbit.
- Throw Tankards! Toast your friends, throw back a cold one, then throw your mug.
- Adds Axe secondary attack on par with other weapons with strong secondary attacks, like maces and swords.
- Toggle between melee and throwing attacks with a key press.
- Optionally stack throwable weapons; up to 3 Axes, Clubs or Maces, a 'quiver' of 5 Spears, and a 'sheath' of 10 Knives per slot. (see Caution below)
- Has a weapon 'finder' to help locate thrown weapons.
- MaxAxe can automatically equip a backup weapon so you're never fumbling to find another weapon in combat.

## New
- 0.2.4 Updated for Mistlands
- 0.2.4 Added ability for Mjolnir (from Azumatt) to return. See Compatibility.

- 0.2.3 Fixed bug in multiplayer when another player could 'capture' thrown weapon mid-flight. See _multiplayer_ in notes.
- 0.2.3 Added configuration setting to throw on _release_ of ThrowOne and ThrowShield keys

## Configuration

### General

- **MeleeAttack**: If True, uses the melee secondary attack. Toggle in-game using the _ToggleMeleeAttack_ key.
- **ToggleMeleeAttack**: Press this key to toggle in-game between Throw and Melee mode for secondary attacks on enabled one-handed weapons. Default is LeftAlt+B.
- **ThrowOne**: Press this key (even in melee mode) to throw the currently equipped weapon (if throwable). Default is T.
- **ThrowShield**: Press this key to throw your currently equipped round shield. Default is G.
- **ThrowOnRelease**: Set to True to throw when the _ThrowOne_ or _ThrowShield_ keys are released instead of pressed. Default is False.
- **EnableAxes**: Set to True to enable secondary melee and throwing attacks for one-handed axes.
- **EnableSpears**: Set to True to enable secondary melee attack for spears.
- **EnableKnives**: Set to True to enable secondary throwing attack for knives.
- **EnableSwords**: Set to True to enable secondary throwing attack for swords.
- **MjolnirMode**: Set to True to have Frostner return to your hand after throwing. Default is False.
- **EnableClubs**: Set to True to enable secondary throwing attacks for clubs, including maces, Frostner, torches, stones & tankards.
- **EnableShields**: Set to true to enable hurling your round shield with the _ThrowShield_ key. Your shield must be equipped.
- **UnderhandShield**: Set to True to throw your shield using an underhand throw. Shields must also be enabled. Default is False.
- **WeaponStones**: Set to True to equip and attack with stones. Clubs must also be enabled.
- **StackableWeapons**: Set to True to allow throwable weapons to stack. See _Stackable Weapons_ below before enabling.
- **AutoMelee**: Set to True to automatically switch to melee mode after weapon is thrown (or to prevent throwing the last weapon in a stack).
- **AutoEquip**: Set to True to automatically equip another weapon after a throw. Will try to find the same weapon in inventory first.
- **TargetAdjustment**: Adjusts the vertical throwing impact point in relation to the target reticle (the +). Default is -7. Vanilla Valheim is 0.
- **WeaponFinder**: Type of 'locator' effect added to thrown weapon to make it easier to find. Can be 'Wishbone', 'Autopick' or 'None'. Default is Wishbone.

### Utility

- **LogLevel**: Controls the level of information in the log.
- **ItemAmountColor**: Color of item quantity text in hotbar and inventory. Default is yellow (FFEB04FF). Active only when _StackableWeapons_ is true.
- **ForceSimpleTrail**: Forces MaxAxe to use a "simple" trail.

### In-game reconfiguration

You can use Configuration Manager (or similar) mod to change the configuration without exiting the game. You can force a configuration update from the chat window (press Enter) then type:

	/maxaxe config
   
You can also change most settings using this syntax:

	/maxaxe [setting]=[value] , i.e., /maxaxe enableaxes=true

Note that all the _EnableX_, _StackableWeapons_, _MjolnirMode_ and _WeaponStones_ settings are controlled by the server in multiplayer.

### Stackable Weapons

**READ BEFORE ENABLING STACKABLE WEAPONS**

If you set _StackableWeapons_ to 'true', one-handed weaponse will stack in both player and chest inventory.

If you have stacked weapons in your player inventory, you will not be able to turn StackableWeapons 'off' in-game.

  Split weapon stacks into individual weapons before you disable _StackableWeapons_ or uninstall MaxAxe 

If you have turned off StackableWeapons outside of the game, but still have stacked weapons in your player inventory _or nearby chests_, MaxAxe will automatically turn _StackableWeapons_ back on, so you don't lose the stacks. Unstack these items before turning off _StackableWeapons_. The log file will contain a warning indicating which weapon stack was found and if it was in inventory or a chest (but not which chest)

If you have uninstalled MaxAxe and restarted the game but had stacked weapons in chests, you may still be able to re-install MaxAxe and retrieve the stacked weapons. 

If the stack was in player inventory, you will need to exit the game, re-install MaxAxe, and copy the player backup (yourCharacter.fch.old) to the current character file _before_ restarting the game again.

**Durability** With release 0.1.6 stacks of weapons will have durability applied to each weapon in the stack separately (virtually). The durability bar will decrease on the weapon until it breaks. The broken weapon will be removed from the stack, and placed in a separate slot. The durability bar on the 'next' weapon in the stack will be 'full'. If additional weapons of the same type/level break, they will be stacked with existing broken weapons of the same type/level. **NOTE** _If no slot is available for the broken weapon, it will be dropped (but a weapon finder will be added)_.

When stacking weapons, the following applies:

- You can split stacks, but the split stack will have the same durability as the source stack.
- You cannot merge broken weapons into a stack with durability.
- You cannot merge durable weapons into a broken stack (prevents accidentally 'breaking' good weapons)
- You can merge durable weapons into a stack with different durability, but the merged stack will use the durability of the lesser.
- You can merge broken weapons of the same type/level together.
- If you pick up multiple thrown weapons, the stack will use the durability of the least durable weapon, i.e., the 'current' weapon will be the least durable (except if also using EQS).

### Compatibility issues & defects

- _MjolnirMode_ is compatible with Azumatt's Mjolnir. 
- You cannot throw (or return via _MjolnirMode_) FlippyFlip3's Mjolnir - Thor's Hammer. It's not defined as a one-handed weapon.
- _StackableWeapons_ is not compatible with Epic Loot. If you turn on stackable weapons with Epic Loot, EpicLoot will not be able to create/drop magical One Handed weapons. Existing weapons will continue to work.
- _StackableWeapons_ may not be compatible with custom one-handed weapon prefabs. Prefabs loaded after weapon stack sizes are adjusted will not stack.
- If you're using DualWield with _StackableWeapons_ and throw your weapon then pick it up, your weapon will be added to the stack and not re-equipped. You'll need to split the stack into two in order to re-equip your off-hand weapon.

- If you find a compatibility issue you can post it on NexusMods. Be sure to include the mod name and version you think may be incompatible.
- If you have a bug please report it on NexusMods. If you do post a bug report, please make sure to include the following:
    - Your version of this mod
    - What you were doing, or attempting to do when it happened
    - If it's repeatable - i.e., can you duplicate it?
    - The exact behavior you observed (or didn't observe)
    - If possible, a capture of the log file with errors (errors always begin with this mod's name)

### Notes

- Multiplayer:
    - If a player clicks on a thrown item in-flight (unlikely but possible if you're a ninja or elf) a thrown weapon can be 'captured' by another player. It will not be 'auto' captured in flight if auto pickup is on.
    - If the attacker has PVP damage enabled, but the target does not, the target may automatically pick up the item after it hits. This is the same behavior as a thrown spear in vanilla Valheim.
- If using _ThrowOnRelease_ with a multi key combo, both keys must be released at *exactly* the same time. A single key is recommended.
- MjolnirMode is rather OP, but it's intended for fun, not roleplay. It only works with Frostner (it's magic, after all). Note that this is still in "alpha" testing. Report issues on Nexus.	
    - Try not to throw Frostner into deep water. If you do, you may need to move closer before it returns, and it may take a little time.
- You cannot upgrade weapons in a stack. Unstack a weapon before upgrading.
- Torches will remain lit for a short time after being thrown. Toss into dark areas for a bit of light!
- The spear secondary melee attack uses a powerful spear 'thrust'. Unfortunately the spear is pointed in the wrong direction(!), so this is done with the spear's butt, and therefore delivers Blunt damage!
- Weapon finders are not persisted between sessions. If you don't pick up a weapon and log off, it will no longer display a finder.
- Stones are not recoverable. Just pick up another one.
- Shields deliver attack damage equivalent to their Block damage, but do not factor in Blocking skill to the damage.
- Thrown (and melee) tankard attacks don't require mead in your inventory.
- If _StackableWeapons_ is true, _all_ stacked items amount text will appear in the color configured by _ItemAmountColor_
- Sorry, but throwing weapon trails and shield rotation/decoration in flight are not visible to other players

- Shameless plugs for other mods (mirror on Thunderstore):
    - WolfPack: Control all your tame creatures at once! https://www.nexusmods.com/valheim/mods/1549/
    - RequipMe: Instantly re-equip your best gear from your tombstone! https://www.nexusmods.com/valheim/mods/1615
    - Reely SpecTackleLure: Fishing skill, craftable equipment, fishing aids and deep-sea danger... https://www.nexusmods.com/valheim/mods/1655
    - UnRemove: Restore your destroyed pieces without rebuilding them. https://www.nexusmods.com/valheim/mods/1676
	- Quiet Portals: Adjust the volume of active portals or silence them completely. https://www.nexusmods.com/valheim/mods/1981
	- Quiet Crafting: Change the volume of fabrication stations, construction build & destroy sounds, and other noisy things. https://www.nexusmods.com/valheim/mods/1990
    
- Your comments and feedback are always welcome. Please feel free to post or send a note on NexusMods.